<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Communication Code</TITLE>
<link href="lic_15.html" rel=Next>
<link href="lic_13.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_13.html">previous</A>, <A HREF="lic_15.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC14" HREF="lic_toc.html#TOC14">Communication Code</A></H3>


<PRE>
 A(N,N), B(N,N)
 DISTRIBUTE (*,BLOCK) A, B
 do i = 2, N-1
   do j = i, N-1
     A(i, j) = A(i-1, j-1)
   enddo
 enddo
</PRE>

<P>
<A NAME="IDX158"></A>

</P>
<P>
For the above code segment, the last two examples find the computation
decomposition (see section <A HREF="lic_12.html#SEC12">Owner Computes Rule</A>) and that communication is
needed when <CODE>Ps &#62; Pr</CODE> (see section <A HREF="lic_13.html#SEC13">Find Existence of Communication</A>).  In
this example separate loop nests for the distributed loop as well as
receive and send instructions are found.

</P>
<P>
<A NAME="IDX159"></A>
<A NAME="IDX160"></A>
<A NAME="IDX161"></A>
<A NAME="IDX162"></A>
<A NAME="IDX163"></A>
<A NAME="IDX164"></A>

</P>

<PRE>
#iter = [2 &#60;= i &#60;= N - 1
         i &#60;= j &#60;= N - 1]

#dists = [ blk*Ps &#60;= bsy &#60; blk*Ps + blk ]
#distr = [ blk*Pr &#60;= bry &#60; blk*Pr + blk ]

#lhs = [bsx = i
        bsy = j ]

#rhs = [brx = i
        bry = j - 1 ]

#loop = { iter, dists, lhs }
#loop = loop.order(N Ps i j bsx bsy)
#loop = loop.rename(N P i j bx by)
loop.code(2)

#comm = { iter, dists, distr, lhs, rhs
          [ Ps &#62; Pr ] }

#comms = comm.order(N Ps i Pr j bsx bsy brx bry)
#comms = comms.rename(N P i Pr j bx by brx bry)
comms.code(2)

#commr = comm.order(N Pr i Ps j brx bry bsx bsy)
#commr = commr.rename(N P i Ps j bx by bsx bsy)
commr.code(2)
end
</PRE>

<P>
<A NAME="IDX165"></A>

</P>

<P>
The printout of the example session:

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example5
#iter = [2 &#60;= i &#60;= N - 1
         i &#60;= j &#60;= N - 1]

#dists = [ blk*Ps &#60;= bsy &#60; blk*Ps + blk ]
#distr = [ blk*Pr &#60;= bry &#60; blk*Pr + blk ]

#lhs = [bsx = i
        bsy = j ]

#rhs = [brx = i
        bry = j - 1 ]

#loop = { iter, dists, lhs }
#loop = loop.order(N Ps i j bsx bsy)
#loop = loop.rename(N P i j bx by)
loop.code(2)

for(P = 2/blk; P &#60;= (-1+N)/blk; P++)
   for(i = 2; i &#60;= min(-1+N, -1+blk+blk*P); i++)
      for(j = max(blk*P, i); j &#60;= min(-1+N, -1+blk+blk*P); j++) {
         bx = i;
         by = j;
      }

#comm = { iter, dists, distr, lhs, rhs
          [ Ps &#62; Pr ] }

#comms = comm.order(N Ps i Pr j bsx bsy brx bry)
#comms = comms.rename(N P i Pr j bx by brx bry)
comms.code(2)

for(P = (1+blk)/blk; P &#60;= (-1+N)/blk; P++)
   for(i = 2; i &#60;= blk*P; i++) {
      Pr = -1+P;
      j = blk+blk*Pr;
      bx = i;
      by = j;
      brx = i;
      bry = -1+j;
   }

#commr = comm.order(N Pr i Ps j brx bry bsx bsy)
#commr = commr.rename(N P i Ps j bx by bsx bsy)
commr.code(2)

for(P = 1/blk; P &#60;= (-1-blk+N)/blk; P++)
   for(i = 2; i &#60;= blk+blk*P; i++) {
      Ps = 1+P;
      j = blk*Ps;
      bx = i;
      by = -1+blk*Ps;
      bsx = bx;
      bsy = blk*Ps;
   }

end
&#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX166"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_13.html">previous</A>, <A HREF="lic_15.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
